
set echo on
set serveroutput on

CREATE FUNCTION function_name(
                p_arg1 IN INTEGER DEFAULT 0,
                p_arg2 IN INTEGER DEFAULT 0,
                p_arg3 IN INTEGER DEFAULT 0 ) RETURN INTEGER IS
BEGIN
   RETURN p_arg1 + p_arg2 + p_arg3;
END function_name;
/

SELECT function_name(10,20,30)
FROM   dual;

SELECT function_name(p_arg1 => 10,
                     p_arg2 => 20,
                     p_arg3 => 30)
FROM   dual;

SELECT function_name(p_arg1 => 10,
                     p_arg3 => 30)
FROM   dual;

SELECT function_name(10, p_arg3=>30)
FROM   dual;

SELECT DBMS_UTILITY.GET_HASH_VALUE(name      => 'ABCDE',
                                   base      => 16,
                                   hash_size => 1024)
FROM   dual;

SELECT UPPER(ch => 'hello world')
FROM   dual;

DECLARE
   v VARCHAR2(20);
BEGIN
   v := UPPER(ch => 'hello world');
   DBMS_OUTPUT.PUT_LINE(v);
END;
/

exec print_table('SELECT * FROM v$sqlfn_metadata WHERE name = ''UPPER''');
exec print_table('SELECT * FROM v$sqlfn_arg_metadata WHERE func_id = 33');

CREATE PACKAGE package_name AS

   FUNCTION function_name(
            p_arg IN INTEGER
            ) RETURN INTEGER;

   FUNCTION function_name(
            p_parameter IN INTEGER
            ) RETURN INTEGER;

END package_name;
/

CREATE PACKAGE BODY package_name AS

   FUNCTION function_name(
            p_arg IN INTEGER
            ) RETURN INTEGER IS
   BEGIN
      RETURN p_arg;
   END function_name;

   FUNCTION function_name(
            p_parameter IN INTEGER
            ) RETURN INTEGER IS
   BEGIN
      RETURN -p_parameter;
   END function_name;

END package_name;
/

SELECT package_name.function_name(10)
FROM   dual;

SELECT package_name.function_name(p_arg => 10)
FROM   dual;

SELECT package_name.function_name(p_parameter => 10)
FROM   dual;


