
set echo on
set serveroutput on

DECLARE
   s SIMPLE_INTEGER;
BEGIN
   s := 0;
END;
/

DECLARE
   s SIMPLE_INTEGER := 0;
BEGIN
   DBMS_OUTPUT.PUT_LINE('Simple integer is ' || s);
END;
/

CREATE PROCEDURE simple_integer_parameter(
                 p_simple_integer IN SIMPLE_INTEGER
                 ) IS
BEGIN
   DBMS_OUTPUT.PUT_LINE(p_simple_integer);
END simple_integer_parameter;
/

exec simple_integer_parameter(NULL);

CREATE OR REPLACE PROCEDURE simple_integer_parameter(
                            p_simple_integer IN SIMPLE_INTEGER DEFAULT NULL
                            ) IS
BEGIN
   DBMS_OUTPUT.PUT_LINE(p_simple_integer);
END simple_integer_parameter;
/

show errors

DECLARE

   s SIMPLE_INTEGER := 0;
   p PLS_INTEGER    := 0;
   n PLS_INTEGER    := &power;

BEGIN

   timer.snap();
   FOR i IN 1 .. 10 ** n LOOP
      s := s + 1;
   END LOOP;
   timer.show('SIMPLE_INTEGER');

   timer.snap();
   FOR i IN 1 .. 10 ** n LOOP
      p := p + 1;
   END LOOP;
   timer.show('PLS_INTEGER   ');

END;
/
/
/
/

DECLARE

   sc CONSTANT SIMPLE_INTEGER := 1;
   pc CONSTANT PLS_INTEGER    := 1;
   s  SIMPLE_INTEGER          := 0;
   p  PLS_INTEGER             := 0;
   n  PLS_INTEGER             := &power;

BEGIN

   timer.snap();
   FOR i IN 1 .. 10 ** n LOOP
      s := s + sc - sc + s - s + sc;
   END LOOP;
   timer.show('SIMPLE_INTEGER');

   timer.snap();
   FOR i IN 1 .. 10 ** n LOOP
      p := p + pc - pc + p - p + pc;
   END LOOP;
   timer.show('PLS_INTEGER   ');

END;
/

