
set echo on
set serveroutput on
col plsql_code_type format a20

CREATE PACKAGE ncomp_test AS

   PROCEDURE simple(p_comp IN VARCHAR2);

   PROCEDURE pls(p_comp IN VARCHAR2);

END ncomp_test;
/

CREATE PACKAGE BODY ncomp_test AS

   PROCEDURE simple(p_comp IN VARCHAR2) IS
      s SIMPLE_INTEGER := 0;
   BEGIN
      timer.snap();
      FOR i IN 1 .. 10 ** 8 LOOP
         s := s + 1;
      END LOOP;
      timer.show(p_comp || ' SIMPLE_INTEGER');
   END simple;

   PROCEDURE pls(p_comp IN VARCHAR2) IS
      p PLS_INTEGER := 0;
   BEGIN
      timer.snap();
      FOR i IN 1 .. 10 ** 8 LOOP
         p := p + 1;
      END LOOP;
      timer.show(p_comp || ' PLS_INTEGER   ');
   END pls;

END ncomp_test;
/

SELECT name, type, plsql_code_type
FROM   user_plsql_object_settings
WHERE  name = 'NCOMP_TEST';

BEGIN
   ncomp_test.simple('INTERPRETED');
   ncomp_test.pls('INTERPRETED');
END;
/

ALTER PACKAGE ncomp_test COMPILE PLSQL_CODE_TYPE = NATIVE;

BEGIN
   ncomp_test.simple('NATIVE');
   ncomp_test.pls('NATIVE');
END;
/

SELECT name, type, plsql_code_type
FROM   user_plsql_object_settings
WHERE  name = 'NCOMP_TEST';

ALTER SESSION SET PLSQL_CODE_TYPE = NATIVE;

CREATE PROCEDURE native_by_default AS
BEGIN
   NULL;
END native_by_default;
/

SELECT name, type, plsql_code_type
FROM   user_plsql_object_settings
WHERE  name = 'NATIVE_BY_DEFAULT';

ALTER SESSION SET PLSQL_CODE_TYPE = INTERPRETED;

CREATE PROCEDURE interpreted_procedure AS
BEGIN
   NULL;
END;
/

SELECT name, type, plsql_code_type
FROM   user_plsql_object_settings
WHERE  name = 'INTERPRETED_PROCEDURE';

ALTER SESSION SET PLSQL_CODE_TYPE = NATIVE;

ALTER PROCEDURE interpreted_procedure COMPILE;

SELECT name, type, plsql_code_type
FROM   user_plsql_object_settings
WHERE  name = 'INTERPRETED_PROCEDURE';

ALTER SESSION SET PLSQL_CODE_TYPE = INTERPRETED;

ALTER PROCEDURE interpreted_procedure COMPILE REUSE SETTINGS;

SELECT name, type, plsql_code_type
FROM   user_plsql_object_settings
WHERE  name = 'INTERPRETED_PROCEDURE';

ALTER PACKAGE ncomp_test COMPILE BODY PLSQL_CODE_TYPE = INTERPRETED;

SELECT name, type, plsql_code_type
FROM   user_plsql_object_settings
WHERE  name = 'NCOMP_TEST';

